﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Odbc;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Threading;
using System.Windows.Forms;
using static RetiSocialiAlgoritmo.Form2;

namespace RetiSocialiAlgoritmo {
    public partial class Form2 : Form {

        // Query per creazione dei file CSV da Mysql

        //SELECT idA as Source, idB as Target, similaritScore as Weight, same,discord,disagree,opposite FROM reti_confronti where similaritScore>70;

        //SELECT reti_user.userid as id, username as label, anno as Year, genere as Gender, preferito, tag, count(reti_voti.voto) as nvoti
        //FROM reti_user inner join reti_voti
        //on reti_user.userid = reti_voti.userid
        //where reti_voti.voto!=0
        //group by reti_user.userid
        //having nvoti>5

        // Query completa per selezionare le persone piu' vicine a noi ...    
        //  SELECT idA, idB, reti_confronti.comparisonID,similaritScore, reti_suggerimenti.list, reti_suggerimenti.userID_to
        //  FROM reti_confronti
        //  inner join
        //  reti_suggerimenti on
        //  reti_confronti.comparisonID=reti_suggerimenti.comparisonID
        //  where (idA= 10 or idB = 10) and similaritScore>60 
        //  having userID_to = 10
        //  order by similaritScore desc
        //  limit 10    

        //Query selezionando solo 2 campi ....
        //        SELECT
        //            similaritScore,
        //            reti_suggerimenti.list,
        //            reti_suggerimenti.userID_to
        //        FROM
        //            reti_confronti
        //                INNER JOIN
        //            reti_suggerimenti ON reti_confronti.comparisonID = reti_suggerimenti.comparisonID
        //        WHERE
        //            (idA = 10 OR idB = 10)
        //                AND similaritScore > 60
        //        HAVING reti_suggerimenti.userID_to = 10
        //        ORDER BY similaritScore DESC
        //        LIMIT 10


        public static class Utility {
            public static string MySQLConString = "DRIVER={MySQL ODBC 3.51 Driver};SERVER=localhost;DATABASE=sql960766_3;UID=root;PASSWORD=admin;OPTION=3;";
        }

        List<User> users = new List<User>();
        public int row = 1;
        int nRegion = 8;

        Stopwatch stopwatch = new Stopwatch();

        public Form2() {
            InitializeComponent();
        }

        private void Form2_Load(object sender, EventArgs e) {

        }

        private void btnStart_Click(object sender, EventArgs e) {

            stopwatch.Start();
            console.Text = "Loading all users...";
            console.Text = LoadAllUser();
            console.AppendText(Environment.NewLine);
            console.AppendText("Abbiamo " + users.Count + " utenti da analizzare." + Environment.NewLine);
            console.AppendText("Stopwatch è ad alta definizione? " + Stopwatch.IsHighResolution + Environment.NewLine);

            int totalLink = 0;
            int linkFF = 0;
            int linkMF = 0;
            int linkMM = 0;
            int totNodi = 0;
            int nodiF = 0;
            int nodiM = 0;

            bool firstTimeUser = true;
            char genereUtente = ' ';

            // Ciclo sui confronti su tutti gli utenti
            // partendo nel ciclo interno dall'utente successivo a quello che sto analizzando
            for (int i = 0; i < users.Count - 1; i++) {

                int User1ID = users[i].userid;
                Dictionary<int, int> user1Vote = GetUserVote(User1ID); // Prendo i voti dell'utente 1

                genereUtente = Convert.ToChar(users[i].genere);
                firstTimeUser = true;

                for (int x = i + 1; x < users.Count; x++) {

                    int User2ID = users[x].userid;
                    Dictionary<int, int> user2Vote = GetUserVote(User2ID); // Prendo i voti dell'utente 2

                    // Unisco i voti dell'utente A a B in un unica lista
                    // (poichè il confronto tra A e B è uguale a quello di B con A)                   
                    Dictionary<int, SimilarityFilmsData> _tempMash = MashSimilarityFilmsUser(user1Vote, user2Vote);

                    // Confronto i valori degli utenti
                    SimilarityResoult _temp = UserSimilaryty(_tempMash);

                    // Controllo se ho almeno 5 voti in comune per poter fare un vero confronto ...
                    // Se si salvo nel database il risultato, se no nn è rilavante e quindi continuo con i confronti  
                    int nVote = _temp.countvote_disagree + _temp.countvote_discord + _temp.countvote_opposite + _temp.countvote_same + _temp.countvote_similar;
                    if (nVote >= 5) {
                        //SaveInMysql(User1ID, User2ID, _temp);
                        row++;

                        if (_temp.similaritScore > 70) {
                            if ((users[i].genere == "M") && (users[x].genere == "M")) {
                                linkMM++;
                            }
                            else {
                                if ((users[i].genere == "F") && (users[x].genere == "F")) {
                                    linkFF++;
                                }
                                else {
                                    linkMF++;
                                }
                            }
                            totalLink++;

                            if (firstTimeUser == true) {
                                firstTimeUser = false;
                                if (genereUtente == 'M') {
                                    nodiM++;
                                }
                                else {
                                    nodiF++;
                                }
                                totNodi++;
                            }
                        }

                    }




                }
            }
            console.AppendText("Time elapsed: " + stopwatch.Elapsed + Environment.NewLine + Environment.NewLine);

            stopwatch.Stop();

            console.AppendText("Ci sono    totalLink= " + totalLink + Environment.NewLine);
            console.AppendText("Ci sono      linkFF=" + linkFF + Environment.NewLine);
            console.AppendText("Ci sono      linkMF=" + linkMF + Environment.NewLine);
            console.AppendText("Ci sono      linkMM=" + linkMM + Environment.NewLine);
            console.AppendText("Ci sono nodi totali =" + totNodi + Environment.NewLine);
            console.AppendText("Ci sono nodi Femmina=" + nodiF + Environment.NewLine);
            console.AppendText("Ci sono nodi Maschi=" + nodiM + Environment.NewLine);
        }

        public class User {

            public int userid;
            public string username;
            public int anno;
            public string genere;
            public int preferito;
            public int tag;
            public int nvoti;

            public List<User> myFriends = new List<User>();
            public List<int> suggestMovie = new List<int>();

            public User(int _userid, string _username, int _anno, string _genere, int _preferito, int _tag, int _nvoti) {
                this.userid = _userid;
                this.username = _username;
                this.anno = _anno;
                this.genere = _genere;
                this.preferito = _preferito;
                this.tag = _tag;
                this.nvoti = _nvoti;
            }

            public void AddaFriend(User _friend) {
                this.myFriends.Add(_friend);
            }

            public void AddSuggestMovie(int FilmID) {
                suggestMovie.Add(FilmID);
            }

        }

        public string LoadAllUser() {

            string sql = @"SELECT reti_user.userid, username, anno, genere, preferito, tag, count(reti_voti.voto) as nvoti
                           FROM reti_user inner join reti_voti
                           on reti_user.userid = reti_voti.userid 
                           where reti_voti.voto!=0
                           group by reti_user.userid
                           having nvoti>5";

            OdbcConnection MyConnection = new OdbcConnection(Utility.MySQLConString);
            OdbcCommand com = null;
            OdbcDataReader reader = null;

            try {
                MyConnection.Open();
                using (com = new OdbcCommand(sql, MyConnection)) {
                    using (reader = com.ExecuteReader()) {
                        while (reader.Read()) {
                            int userid = reader.GetInt32(0);
                            string username = reader.GetString(1);
                            int anno = reader.GetInt32(2);
                            string genere = reader.GetString(3);
                            int preferito = reader.GetInt32(4);
                            int tag = reader.GetInt32(5);
                            int nvoti = reader.GetInt32(6);
                            users.Add(new User(userid, username, anno, genere, preferito, tag, nvoti));
                        }
                    }
                }
            }
            catch (Exception e) {
                return "(LoadAllUser) > Mysql > " + e.Message;
            }
            finally {
                // close reader
                if (reader != null) reader.Close();
                // close connection
                if (MyConnection != null) MyConnection.Close();
            }

            return "";

        }

        public Dictionary<int, int> GetUserVote(int userID) {

            Dictionary<int, int> userVote = new Dictionary<int, int>();

            string sql = "SELECT filmid, voto FROM reti_voti where userid=?";

            OdbcConnection MyConnection = new OdbcConnection(Utility.MySQLConString);
            OdbcCommand com = null;
            OdbcDataReader reader = null;

            try {
                MyConnection.Open();
                using (com = new OdbcCommand(sql, MyConnection)) {

                    OdbcParameter param1 = new OdbcParameter();
                    param1.DbType = DbType.Int32;
                    param1.Value = userID;
                    com.Parameters.Add(param1);

                    using (reader = com.ExecuteReader()) {
                        while (reader.Read()) {
                            int filmid = reader.GetInt32(0);
                            int voto = reader.GetInt32(1);
                            userVote.Add(filmid, voto);
                        }
                    }
                }
            }
            catch (Exception e) {
                string err = "(GetUserVote) > Mysql > " + e.Message;
            }
            finally {
                // close reader
                if (reader != null) reader.Close();
                // close connection
                if (MyConnection != null) MyConnection.Close();
            }

            return userVote;

        }

        public class Film {
            public int voto;
            public int ID;
            public Film(int _id, int _voto) {
                this.ID = _id;
                this.voto = _voto;
            }
        }

        public SimilarityResoult UserSimilaryty(Dictionary<int, SimilarityFilmsData> _similarityDictionary) {

            int total = 0; // film visti in comune

            //double VotePoints_opposite = 0;
            double VotePoints_disagree = 0.3;
            double VotePoints_discord = 0.5;
            double VotePoints_similar = 0.8;
            //double VotePoints_same = 1;

            int countvote_opposite = 0; // Ogni volta che i voti sono mooolto contrastanti
            int countvote_disagree = 0; // Molto in disaccordo ma nn l'opposto un pò in disaccordo es io 2 tu 3 
            int countvote_discord = 0; // Voto un pò in disaccordo es io 2 tu 3 
            int countvote_similar = 0; // Voto simile es io 4 tu 5, io 2 e tu 1
            int countvote_same = 0;  // Voto uguale tutti e 2 votiamo 3 

            List<int> listSuggestAtoB = new List<int>(); // Film che A suggerisce ad B
            List<int> listSuggestBtoA = new List<int>(); // Film che B suggerisce ad A

            foreach (KeyValuePair<int, SimilarityFilmsData> row in _similarityDictionary) {

                int filmID = row.Value.filmID;
                int votoUserA = row.Value.UserAVote;
                int votoUserB = row.Value.UserBVote;

                // Film che A e B non hanno visto e che consiglia all'altro
                if ((votoUserA == 0) && ((votoUserB == 5) || (votoUserB == 4))) {
                    listSuggestBtoA.Add(filmID);
                    continue;
                }
                if ((votoUserB == 0) && ((votoUserA == 5) || (votoUserA == 4))) {
                    listSuggestAtoB.Add(filmID);
                    continue;
                }

                // il film  A o B non lo hanno visto, quindi inutile continuare il cofronto, esco dal ciclo
                if ((votoUserA == 0) || (votoUserB == 0)) {
                    continue;
                }

                // il Film è stato visto da entrambi ed entrambi, ha senso fare il confronto

                total++; // Incremento il contatore

                // Stesso voto = maggior "legame"
                if ((votoUserA == votoUserB) && (votoUserA != 0)) {
                    //score += VotePoints_same;
                    countvote_same++;
                    continue;
                }

                // Voto congiunto che mi permette di dare un Grado di "amicizia" in base hai 2 voti
                // Es A vota 3 e B vota 2
                // _choose = (3*10)+2 = 32;
                int _choose = (votoUserA * 10) + votoUserB;

                switch (_choose) {
                    // Molto simili 1 e 2 oppure 4 o 5
                    case 12:
                    case 21:
                    case 45:
                    case 54:
                        //score += VotePoints_similar;
                        countvote_similar++;
                        break;
                    // Non uguali ma qualcosa in comune ...
                    case 34:
                    case 43:
                        //score += VotePoints_disagree;
                        countvote_disagree++;
                        break;
                    // In contrasto ma non agli antipodi ...
                    case 13:
                    case 23:
                    case 32:
                    case 53:
                        //score += VotePoints_discord;
                        countvote_discord++;
                        break;
                    // Pareri piu' discordanti possibile ...
                    case 14:
                    case 15:
                    case 24:
                    case 25:
                    case 31:
                    case 35:
                    case 41:
                    case 42:
                    case 51:
                    case 52:
                        //score += VotePoints_opposite;
                        countvote_opposite++;
                        break;
                    default:
                        string x = "errore";
                        break;
                }
            }

            int similarity = 0;
            if (total != 0) {
                double temp = ((countvote_disagree * VotePoints_disagree) + (VotePoints_discord * countvote_discord) + (VotePoints_similar * countvote_similar) + (countvote_same));
                temp = temp / total;
                similarity = Convert.ToInt32(temp * 100);
            }

            return new SimilarityResoult(similarity, listSuggestBtoA, listSuggestAtoB, countvote_opposite, countvote_disagree, countvote_disagree, countvote_similar, countvote_same);

        }

        public Dictionary<int, SimilarityFilmsData> MashSimilarityFilmsUser(Dictionary<int, int> user1_voteList, Dictionary<int, int> user2_voteList) {

            Dictionary<int, SimilarityFilmsData> _mash = new Dictionary<int, SimilarityFilmsData>();

            // Aggiungo i voti di utenteA 
            foreach (KeyValuePair<int, int> us1 in user1_voteList) {
                // Se anche B ha visto il film
                if (user2_voteList.ContainsKey(us1.Key) == true) {
                    _mash.Add(us1.Key, new SimilarityFilmsData(us1.Key, user1_voteList[us1.Key], user2_voteList[us1.Key]));
                }
                else { // Altrimenti mezzo 0 come voto....
                    _mash.Add(us1.Key, new SimilarityFilmsData(us1.Key, user1_voteList[us1.Key], 0));
                }
            }

            // Aggiungo anche i film che ha visto B ma nn A
            foreach (KeyValuePair<int, int> us2 in user2_voteList) {
                // Se anche B ha visto il film
                if (_mash.ContainsKey(us2.Key) == false) {
                    _mash.Add(us2.Key, new SimilarityFilmsData(us2.Key, 0, user2_voteList[us2.Key]));
                }
            }


            return _mash;

        }

        public class SimilarityFilmsData {
            public int filmID;
            public int UserAVote;
            public int UserBVote;
            public SimilarityFilmsData(int _filmID, int _AVote, int _Bvote) {
                this.filmID = _filmID;
                this.UserAVote = _AVote;
                this.UserBVote = _Bvote;
            }
        }

        public class SimilarityResoult {

            public List<int> suggetMovieListAtoB = new List<int>();
            public List<int> suggetMovieListBtoA = new List<int>();

            public int similaritScore;

            public int countvote_opposite = 0; // Ogni volta che i voti sono mooolto contrastanti aggiungo 1
            public int countvote_disagree = 0; // Molto in disaccordo ma nn l'opposto un pò in disaccordo es io 2 tu 3 
            public int countvote_discord = 0; // Voto un pò in disaccordo es io 2 tu 3 
            public int countvote_similar = 0; // Voto simile es io 4 tu 5, io 2 e tu 1
            public int countvote_same = 0; // Voto uguale tutti e 2 votiamo 3 

            public SimilarityResoult(int _score, List<int> _listAtoB, List<int> _listBtoA, int _opposite, int _disagree, int _discord, int _similar, int _same) {
                this.similaritScore = _score;
                this.suggetMovieListAtoB = _listAtoB;
                this.suggetMovieListBtoA = _listBtoA;
                this.countvote_opposite = _opposite;
                this.countvote_disagree = _disagree;
                this.countvote_discord = _discord;
                this.countvote_similar = _similar;
                this.countvote_same = _same;
            }
        }


        public static void SaveInMysql(int idA, int idB, SimilarityResoult mySimilarityResoult) {

            string listMovieAtoB = String.Join(";", mySimilarityResoult.suggetMovieListAtoB);
            string listMovieBtoA = String.Join(";", mySimilarityResoult.suggetMovieListBtoA);

            // Creo una stringa unica che identifica la relazione tra A e B
            string comparisonId = (idA < idB) ? idA + "." + idB : idB + "." + idA;

            string sql = @"INSERT INTO `reti_confronti` (`idA`, `idB`,`comparisonId`, `same`, `similar`, `discord`, `disagree`, `opposite`, `similaritScore`) 
                VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?);";

            OdbcConnection MyConnection = new OdbcConnection(Utility.MySQLConString);

            OdbcCommand com = null;
            OdbcDataReader reader = null;

            try {

                MyConnection.Open();

                using (com = new OdbcCommand(sql, MyConnection)) {

                    OdbcParameter param1 = new OdbcParameter();
                    param1.DbType = DbType.Int32;
                    param1.Value = idA;
                    com.Parameters.Add(param1);

                    OdbcParameter param2 = new OdbcParameter();
                    param2.DbType = DbType.Int32;
                    param2.Value = idB;
                    com.Parameters.Add(param2);

                    OdbcParameter param2A = new OdbcParameter();
                    param2A.DbType = DbType.String;
                    param2A.Value = comparisonId;
                    com.Parameters.Add(param2A);

                    OdbcParameter param3 = new OdbcParameter();
                    param3.DbType = DbType.Int32;
                    param3.Value = mySimilarityResoult.countvote_same;
                    com.Parameters.Add(param3);

                    OdbcParameter param4 = new OdbcParameter();
                    param4.DbType = DbType.Int32;
                    param4.Value = mySimilarityResoult.countvote_similar;
                    com.Parameters.Add(param4);

                    OdbcParameter param5 = new OdbcParameter();
                    param5.DbType = DbType.Int32;
                    param5.Value = mySimilarityResoult.countvote_discord;
                    com.Parameters.Add(param5);

                    OdbcParameter param6 = new OdbcParameter();
                    param6.DbType = DbType.Int32;
                    param6.Value = mySimilarityResoult.countvote_disagree;
                    com.Parameters.Add(param6);

                    OdbcParameter param7 = new OdbcParameter();
                    param7.DbType = DbType.Int32;
                    param7.Value = mySimilarityResoult.countvote_opposite;
                    com.Parameters.Add(param7);

                    OdbcParameter param8 = new OdbcParameter();
                    param8.DbType = DbType.Int32;
                    param8.Value = mySimilarityResoult.similaritScore;
                    com.Parameters.Add(param8);

                    com.ExecuteNonQuery();

                }

                if (String.IsNullOrEmpty(listMovieBtoA) == false) {

                    sql = "INSERT INTO `reti_suggerimenti` (`userID_from`, `userID_to`, `list`, `comparisonId`) VALUES (?, ?, ?, ?);";

                    using (com = new OdbcCommand(sql, MyConnection)) {

                        OdbcParameter param1 = new OdbcParameter();
                        param1.DbType = DbType.Int32;
                        param1.Value = idA;
                        com.Parameters.Add(param1);

                        OdbcParameter param2 = new OdbcParameter();
                        param2.DbType = DbType.Int32;
                        param2.Value = idB;
                        com.Parameters.Add(param2);

                        OdbcParameter param3 = new OdbcParameter();
                        param3.DbType = DbType.String;
                        param3.Value = listMovieBtoA;
                        com.Parameters.Add(param3);

                        OdbcParameter param4 = new OdbcParameter();
                        param4.DbType = DbType.String;
                        param4.Value = comparisonId;
                        com.Parameters.Add(param4);

                        com.ExecuteNonQuery();
                    }
                }


                if (String.IsNullOrEmpty(listMovieAtoB) == false) {

                    sql = "INSERT INTO `reti_suggerimenti` (`userID_from`, `userID_to`, `list`, `comparisonId`) VALUES (?, ?, ?, ?);";

                    using (com = new OdbcCommand(sql, MyConnection)) {

                        OdbcParameter param1 = new OdbcParameter();
                        param1.DbType = DbType.Int32;
                        param1.Value = idB;
                        com.Parameters.Add(param1);

                        OdbcParameter param2 = new OdbcParameter();
                        param2.DbType = DbType.Int32;
                        param2.Value = idA;
                        com.Parameters.Add(param2);

                        OdbcParameter param3 = new OdbcParameter();
                        param3.DbType = DbType.String;
                        param3.Value = listMovieAtoB;
                        com.Parameters.Add(param3);

                        OdbcParameter param4 = new OdbcParameter();
                        param4.DbType = DbType.String;
                        param4.Value = comparisonId;
                        com.Parameters.Add(param4);

                        com.ExecuteNonQuery();

                    }
                }


            }
            catch (Exception e) {
                string catchError = "(SaveSimilarityResoult) > Mysql > " + e.Message;
            }
            finally {
                // close reader
                if (reader != null) reader.Close();
                // close connection
                if (MyConnection != null) MyConnection.Close();
            }

        }

        public class Worker {

            int idA; int idB;
            SimilarityResoult mySimilarityResoult;

            public Worker(int _idA, int _idB, SimilarityResoult _resoult) {
                this.idA = _idA;
                this.idB = _idB;
                this.mySimilarityResoult = _resoult;
            }

            // This method will be called when the thread is started.
            public void DoWork() {
                SaveSimilarityResoult();
            }

            public void RequestStop() {
                _shouldStop = true;
            }

            // Volatile is used as hint to the compiler that this data member will be accessed by multiple threads.
            private volatile bool _shouldStop;

            public string SaveSimilarityResoult() {

                string listMovieAtoB = String.Join(";", mySimilarityResoult.suggetMovieListAtoB);
                string listMovieBtoA = String.Join(";", mySimilarityResoult.suggetMovieListBtoA);

                // Creo una stringa unica che identifica la relazione tra A e B
                string comparisonId = (idA < idB) ? idA + "." + idB : idB + "." + idA;

                string sql = @"INSERT INTO `reti_confronti` (`idA`, `idB`,`comparisonId`, `same`, `similar`, `discord`, `disagree`, `opposite`, `similaritScore`) 
                VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?);";

                OdbcConnection MyConnection = new OdbcConnection(Utility.MySQLConString);

                OdbcCommand com = null;
                OdbcDataReader reader = null;

                try {

                    MyConnection.Open();

                    using (com = new OdbcCommand(sql, MyConnection)) {

                        OdbcParameter param1 = new OdbcParameter();
                        param1.DbType = DbType.Int32;
                        param1.Value = idA;
                        com.Parameters.Add(param1);

                        OdbcParameter param2 = new OdbcParameter();
                        param2.DbType = DbType.Int32;
                        param2.Value = idB;
                        com.Parameters.Add(param2);

                        OdbcParameter param2A = new OdbcParameter();
                        param2A.DbType = DbType.String;
                        param2A.Value = comparisonId;
                        com.Parameters.Add(param2A);

                        OdbcParameter param3 = new OdbcParameter();
                        param3.DbType = DbType.Int32;
                        param3.Value = mySimilarityResoult.countvote_same;
                        com.Parameters.Add(param3);

                        OdbcParameter param4 = new OdbcParameter();
                        param4.DbType = DbType.Int32;
                        param4.Value = mySimilarityResoult.countvote_similar;
                        com.Parameters.Add(param4);

                        OdbcParameter param5 = new OdbcParameter();
                        param5.DbType = DbType.Int32;
                        param5.Value = mySimilarityResoult.countvote_discord;
                        com.Parameters.Add(param5);

                        OdbcParameter param6 = new OdbcParameter();
                        param6.DbType = DbType.Int32;
                        param6.Value = mySimilarityResoult.countvote_disagree;
                        com.Parameters.Add(param6);

                        OdbcParameter param7 = new OdbcParameter();
                        param7.DbType = DbType.Int32;
                        param7.Value = mySimilarityResoult.countvote_opposite;
                        com.Parameters.Add(param7);

                        OdbcParameter param8 = new OdbcParameter();
                        param8.DbType = DbType.Int32;
                        param8.Value = mySimilarityResoult.similaritScore;
                        com.Parameters.Add(param8);

                        com.ExecuteNonQuery();

                    }

                    if (String.IsNullOrEmpty(listMovieBtoA) == false) {

                        sql = "INSERT INTO `reti_suggerimenti` (`userID_from`, `userID_to`, `list`) VALUES (?, ?, ?);";

                        using (com = new OdbcCommand(sql, MyConnection)) {

                            OdbcParameter param1 = new OdbcParameter();
                            param1.DbType = DbType.Int32;
                            param1.Value = idA;
                            com.Parameters.Add(param1);

                            OdbcParameter param2 = new OdbcParameter();
                            param2.DbType = DbType.Int32;
                            param2.Value = idB;
                            com.Parameters.Add(param2);

                            OdbcParameter param3 = new OdbcParameter();
                            param3.DbType = DbType.String;
                            param3.Value = listMovieBtoA;
                            com.Parameters.Add(param3);

                            com.ExecuteNonQuery();
                        }
                    }


                    if (String.IsNullOrEmpty(listMovieAtoB) == false) {

                        sql = "INSERT INTO `reti_suggerimenti` (`userID_from`, `userID_to`, `list`) VALUES (?, ?, ?);";

                        using (com = new OdbcCommand(sql, MyConnection)) {

                            OdbcParameter param1 = new OdbcParameter();
                            param1.DbType = DbType.Int32;
                            param1.Value = idB;
                            com.Parameters.Add(param1);

                            OdbcParameter param2 = new OdbcParameter();
                            param2.DbType = DbType.Int32;
                            param2.Value = idA;
                            com.Parameters.Add(param2);

                            OdbcParameter param3 = new OdbcParameter();
                            param3.DbType = DbType.String;
                            param3.Value = listMovieAtoB;
                            com.Parameters.Add(param3);

                            com.ExecuteNonQuery();

                        }
                    }


                }
                catch (Exception e) {
                    return "(SaveSimilarityResoult) > Mysql > " + e.Message;
                }
                finally {
                    // close reader
                    if (reader != null) reader.Close();
                    // close connection
                    if (MyConnection != null) MyConnection.Close();
                }

                return "";


            }


        }

        private void cmdSetup_Click(object sender, EventArgs e) {

            if (users.Count == 0) {
                stopwatch.Start();
                console.Text = "loading...";
                console.Text = LoadAllUser();
                console.AppendText(Environment.NewLine);
                console.AppendText("Abbiamo " + users.Count + " utenti da analizzare." + Environment.NewLine);
                console.AppendText("stopwatch " + Stopwatch.IsHighResolution + Environment.NewLine);
            }

            // Raccomandazione "Grezza", conto quanti film suggeriti uguali ci sono tra i miei amici ...
            for (int i = 0; i < users.Count - 1; i++) {

                int UserID = users[i].userid;
                List<SuggestResoult> temp = GetSuggestedOtherUser(UserID);

                Dictionary<int, int> SuggestedList = new Dictionary<int, int>();

                for (int x = 0; x < temp.Count; x++) {
                    int[] MovieSuggested = temp[x].list.Split(';').Select(int.Parse).ToArray();
                    foreach (int fildid in MovieSuggested) {
                        if (SuggestedList.ContainsKey(fildid) == true) {
                            SuggestedList[fildid] = SuggestedList[fildid] + 1;
                        }
                        else {
                            SuggestedList.Add(fildid, 0);
                        }
                    }
                }

                int k = 0;
                foreach (var item in SuggestedList.OrderByDescending(key => key.Value)) {
                    insertSuggestionRow(UserID, item.Key);
                    if (k == 2) break;
                    k++;
                }

            }

            console.AppendText("Time elapsed: " + stopwatch.Elapsed + Environment.NewLine + Environment.NewLine);

            // Stop.
            stopwatch.Stop();

        }

        private void insertSuggestionRow(int userID, int filmId) {

            List<SuggestResoult> mylist = new List<SuggestResoult>();

            string sql = @"INSERT INTO `reti_raccomandati` (`userID`, `filmId`) VALUES (?, ?);";

            OdbcConnection MyConnection = new OdbcConnection(Utility.MySQLConString);
            OdbcCommand com = null;
            OdbcDataReader reader = null;

            try {
                MyConnection.Open();

                using (com = new OdbcCommand(sql, MyConnection)) {

                    OdbcParameter param1 = new OdbcParameter();
                    param1.DbType = DbType.Int32;
                    param1.Value = userID;
                    com.Parameters.Add(param1);

                    OdbcParameter param2 = new OdbcParameter();
                    param2.DbType = DbType.Int32;
                    param2.Value = filmId;
                    com.Parameters.Add(param2);

                    com.ExecuteNonQuery();
                }
            }
            catch (Exception e) {
                string err = "(Get Suggested Other User) > Mysql > " + e.Message;
            }
            finally {
                // close reader
                if (reader != null) reader.Close();
                // close connection
                if (MyConnection != null) MyConnection.Close();
            }






        }

        private List<SuggestResoult> GetSuggestedOtherUser(int user) {

            List<SuggestResoult> mylist = new List<SuggestResoult>();

            string sql = @"SELECT 
                                similaritScore,
                                reti_suggerimenti.list,
                                reti_suggerimenti.userID_to
                            FROM
                                reti_confronti
                                    INNER JOIN
                                reti_suggerimenti ON reti_confronti.comparisonID = reti_suggerimenti.comparisonID
                            WHERE
                                (idA = ? OR idB = ?)
                                    AND similaritScore > 60
                            HAVING reti_suggerimenti.userID_to = ?
                            ORDER BY similaritScore DESC
                            LIMIT 10";

            OdbcConnection MyConnection = new OdbcConnection(Utility.MySQLConString);
            OdbcCommand com = null;
            OdbcDataReader reader = null;

            try {
                MyConnection.Open();

                using (com = new OdbcCommand(sql, MyConnection)) {

                    OdbcParameter param1 = new OdbcParameter();
                    param1.DbType = DbType.Int32;
                    param1.Value = user;
                    com.Parameters.Add(param1);

                    OdbcParameter param2 = new OdbcParameter();
                    param2.DbType = DbType.Int32;
                    param2.Value = user;
                    com.Parameters.Add(param2);

                    OdbcParameter param3 = new OdbcParameter();
                    param3.DbType = DbType.Int32;
                    param3.Value = user;
                    com.Parameters.Add(param3);

                    using (reader = com.ExecuteReader()) {
                        while (reader.Read()) {
                            int similaritScore = reader.GetInt32(0);
                            string list = reader.GetString(1);
                            mylist.Add(new SuggestResoult(similaritScore, list));
                        }
                    }
                }
            }
            catch (Exception e) {
                string err = "(Get Suggested Other User) > Mysql > " + e.Message;
            }
            finally {
                // close reader
                if (reader != null) reader.Close();
                // close connection
                if (MyConnection != null) MyConnection.Close();
            }

            return mylist;

        }

        public class SuggestResoult {
            public string list;
            public int similaritScore;
            public SuggestResoult(int _similaritScore, string _list) {
                this.similaritScore = _similaritScore;
                this.list = _list;
            }
        }

        private void cmdPredizione_Click(object sender, EventArgs e) {

            stopwatch.Start();

            console.Text = "inizio predizione ...";

            // Query per vedere se ho preso i valori giusti
            // SELECT * FROM sql960766_3.reti_voti where userid IN(172, 36, 161, 122, 12, 76, 115, 22, 10, 1, 67, 164, 61) and filmid = 1;

            List<User> LeaderUser = loadSuperUserV6();
            List<Dictionary<int, int>> LeaderUserVote = new List<Dictionary<int, int>>();

            for (int i = 0; i < LeaderUser.Count; i++) {
                LeaderUserVote.Add(GetUserVote(LeaderUser[i].userid));
            }

            double totalScore = 0;
            double countTotalMatch = 0;
            int countUserNotDone = 0;

            console.Text = LoadAllUser();
            console.AppendText(Environment.NewLine);
            console.AppendText("Abbiamo " + users.Count + " utenti da analizzare." + Environment.NewLine);
            console.AppendText("stopwatch " + Stopwatch.IsHighResolution + Environment.NewLine);

            for (int countUser = 0; countUser < users.Count; countUser++) {

                int userIDBestFriend = GetUserIDBestFriend(users[countUser].userid);

                //LeaderUser.Add(new User(userIDBestFriend, "UserIDBestFriend", 0, "Custom", 0, 1, 0));
                //LeaderUserVote.Add(GetUserVote(userIDBestFriend));

                Dictionary<int, int> user = GetUserVote(users[countUser].userid);

                /*
                Faccio un setup di 10 voti dove vedo l'utente quando è vicino agli altri utenti tipo....
                poi inizio la predizione e vedo quante volte sbaglio
                */

                int[] matrixScore = new int[nRegion];

                int nSetupMach = 10; // Numero di giri prima che l'algoritmo di predizione inizi a funzionare ... 

                double nMatch = 0;
                double RightPrediction = 0;

                for (int idfilm = 1; idfilm <= 50; idfilm++) {

                    // Carico nella matrice i voti dei vari gruppi ...
                    int[] matrixUserScore = SetMatrixValue(LeaderUserVote, idfilm);

                    if (user.ContainsKey(idfilm) == true) {

                        int UserVote = user[idfilm];

                        // Provo ad indovinare se riesco a "predirre" cosa abbia votato l'utente
                        // Ovvero guardo l'utente "leader" che ha piu' punti e suggerisco il suo voto
                        if ((nSetupMach <= 0) && (UserVote != 0)) {

                            int voteSuggest = GetVoteSuggestBySuperUser(matrixUserScore, matrixScore);
                            if (UserVote == voteSuggest) {
                                RightPrediction++;
                            }
                            //else {
                            //    double potenza = 2;
                            //    double delta = UserVote - voteSuggest;
                            //    double deltaPower = Math.Pow(delta, potenza);
                            //    if (deltaPower == 1) {
                            //        RightPrediction = RightPrediction + 0.5;
                            //    }
                            //}
                            nMatch++;
                            //console.AppendText(users[countUser].userid + "." +idfilm + ") UserVote" + UserVote + " Vs voteSuggest:" + voteSuggest + ". Per adesso " + RightPrediction + "/" + nMatch + " successi" + Environment.NewLine);
                        }
                        else {
                            nSetupMach += -1;
                        }

                        if (UserVote != 0) {
                            // Confronto il voto dell'utente con tutti i vari "leader" user
                            // Aggiungo il punto a chi ha il punteggio uguale
                            for (int i = 0; i < matrixUserScore.Length; i++) {
                                if (UserVote == matrixUserScore[i]) {
                                    matrixScore[i] = matrixScore[i] + 1;
                                }
                            }
                        }
                    }
                }

                double score = (RightPrediction / nMatch) * 100;
                if (double.IsNaN(RightPrediction / nMatch) == false) {
                    double not100 = (RightPrediction / nMatch);
                    if (not100 != 1) {
                        totalScore += (RightPrediction / nMatch);
                        countTotalMatch++;
                    }
                    else {
                        string s = "100";
                    }



                }
                else {
                    countUserNotDone++;
                }

                //LeaderUser.RemoveAt(LeaderUser.Count - 1);
                //LeaderUserVote.RemoveAt(LeaderUserVote.Count - 1);

            }


            double mathTotalScore = (totalScore / countTotalMatch) * 100;
            console.AppendText("Il risultato complessivo dell'algoritmo è stato del " + mathTotalScore + "%. Gli utente non analizzati sono stati " + countUserNotDone + Environment.NewLine);
            console.AppendText("Time elapsed: " + stopwatch.Elapsed + Environment.NewLine + Environment.NewLine);
        }

        private int[] SetMatrixValue(List<Dictionary<int, int>> LeaderUserVote, int idfilm) {

            int[] matrix = new int[nRegion];

            matrix[0] = LeaderUserVote[0][idfilm]; // Rossa

            // Tutti gli altri colori ....
            // La i mi indica la posizione nella griglia
            // Se il valore del voto nn lo prendo dalla prima persona (che è in posizione i*2 - 1)  
            // lo prendo dalla seconda (che è in posizione 2i)
            // se nemmeno la seconda ha il voto, allora niente metto zero.
            // Le persone sono aggiunte 2 alla volta per colore, tranne la prima che è idbm.com

            for (int i = 1; i < 7; i++) {

                if (LeaderUserVote[(2 * i - 1)].ContainsKey(idfilm) == true) {
                    if (LeaderUserVote[(2 * i - 1)][idfilm] != 0) {
                        matrix[i] = LeaderUserVote[(2 * i - 1)][idfilm];
                    }
                }
                else {
                    if (LeaderUserVote[(2 * i)].ContainsKey(idfilm) == true) {
                        if (LeaderUserVote[2 * i][idfilm] != 0) {
                            matrix[i] = LeaderUserVote[2 * i][idfilm];
                        }
                    }
                    else {
                        matrix[i] = 0;
                    }
                }
            }

            //try {
            //    matrix[7] = LeaderUserVote[13][idfilm]; // Best Friends
            //}
            //catch {
            //    matrix[7] = 0; //BestFriends
            //}



            return matrix;

        }


        public int GetVoteSuggestBySuperUser(int[] keys, int[] values) {

            // Creo e popolo la lista dei superUser [che hanno espresso il voto per questo film]
            List<RecommendationData> listtSuperUser = new List<RecommendationData>();
            for (int i = 0; i < keys.Length; i++) {
                if (keys[i] != 0) {
                    listtSuperUser.Add(new RecommendationData(i, values[i], keys[i]));
                }
            }
            // La ordino per ordine di importanza dei super user
            RecommendationData[] SuperUser = listtSuperUser.ToArray();
            Array.Sort(SuperUser); // after this donators is sorted

            // Creo una lista dei primi x SuperUser.
            // Ci entra chi ha il punteggio massimo e 
            // Chi ha il punteggio massimo-1
            int maxNmatch = 0;
            double cmd = 0;
            List<RecommendationData> bestUser = new List<RecommendationData>();
            for (int i = SuperUser.Length - 1; i > 0; i--) {
                if (i == SuperUser.Length - 1) {
                    maxNmatch = SuperUser[i].nRightMatch;
                }
                if (SuperUser[i].nRightMatch + 1 >= maxNmatch) {
                    bestUser.Add(SuperUser[i]);
                    cmd += SuperUser[i].nRightMatch;
                }
                else {
                    break;
                }
            }
            // Inserisco nell'arrey dei voti, il voto pesato di ogni superUser
            double[] arrResult = new double[6];
            for (int i = 0; i < bestUser.Count; i++) {
                arrResult[bestUser[i].vote] += (bestUser[i].nRightMatch) / cmd;
            }

            //Ritorno il voto che ha preso il maggior numero di consensi...
            double maxValue = arrResult.Max();
            return arrResult.ToList().IndexOf(maxValue);

        }


        public int GetUserIDBestFriend(int userID) {

            int idA = 0;
            int idB = 0;

            string sql = @"SELECT idA,idB, similaritScore FROM sql960766_3.reti_confronti 
                            where idA = ? or idB = ?
                            order by same desc
                            limit 1";

            OdbcConnection MyConnection = new OdbcConnection(Utility.MySQLConString);
            OdbcCommand com = null;
            OdbcDataReader reader = null;

            try {
                MyConnection.Open();

                using (com = new OdbcCommand(sql, MyConnection)) {

                    OdbcParameter param1 = new OdbcParameter();
                    param1.DbType = DbType.Int32;
                    param1.Value = userID;
                    com.Parameters.Add(param1);

                    OdbcParameter param2 = new OdbcParameter();
                    param2.DbType = DbType.Int32;
                    param2.Value = userID;
                    com.Parameters.Add(param2);


                    using (reader = com.ExecuteReader()) {
                        while (reader.Read()) {
                            idA = reader.GetInt32(0);
                            idB = reader.GetInt32(1);
                        }
                    }
                }
            }
            catch (Exception e) {
                string err = "(Get Suggested Other User) > Mysql > " + e.Message;
            }
            finally {
                // close reader
                if (reader != null) reader.Close();
                // close connection
                if (MyConnection != null) MyConnection.Close();
            }

            if (idA == userID) return idB;
            return idA;

        }




        /// <summary>
        /// Ritorna un int[]
        /// int[0] = il primo valore è il voto suggetito
        /// int[1] = è chi ha suggetito il voto
        /// int[2] = 1 se si è dovuto spostare il voto ad un altro SuperUtente...
        /// </summary>
        /// <param name="matrix">Arrey voti degli utenti</param>
        /// <param name="matrixScore">Matrice utente/similitudine, maggior valore maggior è uguale all'utente</param>
        /// <returns></returns>
        //public void oldtest() {

        //    int[] result = new int[3];

        //    Array.Sort(keys, values);
        //    int arreySize = keys.Length;

        //    for (int i = arreySize - 1; i > 0; i--) {

        //        if (values[i] != 0) {
        //            result[0] = values[i];
        //            result[1] = keys[i];
        //            result[2] = (i == keys.Length) ? 0 : 1;
        //            break;
        //        }

        //    }

        //    return result;

        //}

        public class RecommendationData : IComparable {

            public int superUserID;
            public int nRightMatch;
            public int vote;

            public RecommendationData(int _id, int _nRightMatch, int _vote) {
                this.superUserID = _id;
                this.nRightMatch = _nRightMatch;
                this.vote = _vote;
            }

            public int CompareTo(object obj) {
                // throws invalid cast exception if not of type Donator
                RecommendationData otherDonator = (RecommendationData)obj;
                return this.nRightMatch.CompareTo(otherDonator.nRightMatch);
                throw new NotImplementedException();
            }

        }


        public List<User> loadSuperUserV1() {

            //Regione Viola pageRank

            List<User> LeaderUser = new List<User>();

            LeaderUser.Add(new User(2, "imdb.com", 0, "Rossa", 0, 1, 0));

            LeaderUser.Add(new User(144, "lauraw", 0, "Blu", 0, 2, 0));
            LeaderUser.Add(new User(29, "fertad69", 0, "Blu", 0, 2, 0));

            LeaderUser.Add(new User(137, "Zac", 0, "Verde", 0, 3, 0));
            LeaderUser.Add(new User(9, "danikoch ", 0, "Verde", 0, 3, 0));

            LeaderUser.Add(new User(122, "Bo", 0, "Giallo", 0, 4, 0));
            LeaderUser.Add(new User(43, "matte1", 0, "Giallo", 0, 4, 0));

            LeaderUser.Add(new User(12, "Cocc", 0, "Marrone", 0, 5, 0));
            LeaderUser.Add(new User(3, "Baby", 0, "Marrone", 0, 5, 0));

            LeaderUser.Add(new User(59, "Francesco", 0, "Arancione", 0, 6, 0));
            LeaderUser.Add(new User(56, "nonsonostatoio", 0, "Arancione", 0, 6, 0));

            LeaderUser.Add(new User(41, "la chiamavano jeeg robot", 0, "Giallo", 0, 7, 0));
            LeaderUser.Add(new User(111, "rIO_sK", 0, "Giallo", 0, 7, 0));

            return LeaderUser;

        }


        public List<User> loadSuperUserV2() {

            //Regione Viola deegree

            List<User> LeaderUser = new List<User>();

            LeaderUser.Add(new User(2, "imdb.com", 0, "Rossa", 0, 1, 0));

            LeaderUser.Add(new User(163, "lauraw", 0, "Blu", 0, 2, 0));
            LeaderUser.Add(new User(144, "fertad69", 0, "Blu", 0, 2, 0));

            LeaderUser.Add(new User(122, "Zac", 0, "Verde", 0, 3, 0));
            LeaderUser.Add(new User(13, "danikoch ", 0, "Verde", 0, 3, 0));

            LeaderUser.Add(new User(139, "Bo", 0, "Giallo", 0, 4, 0));
            LeaderUser.Add(new User(53, "matte1", 0, "Giallo", 0, 4, 0));

            LeaderUser.Add(new User(116, "Cocc", 0, "Marrone", 0, 5, 0));
            LeaderUser.Add(new User(137, "Baby", 0, "Marrone", 0, 5, 0));

            LeaderUser.Add(new User(12, "Francesco", 0, "Arancione", 0, 6, 0));
            LeaderUser.Add(new User(35, "nonsonostatoio", 0, "Arancione", 0, 6, 0));

            LeaderUser.Add(new User(20, "la chiamavano jeeg robot", 0, "Giallo", 0, 7, 0));
            LeaderUser.Add(new User(59, "rIO_sK", 0, "Giallo", 0, 7, 0));

            return LeaderUser;

        }



        public List<User> loadSuperUserV3() {

            //Regione Azzurro deegree

            List<User> LeaderUser = new List<User>();

            LeaderUser.Add(new User(1, "imdb.com", 0, "Rossa", 0, 1, 0));

            LeaderUser.Add(new User(47, "lauraw", 0, "Blu", 0, 2, 0));
            LeaderUser.Add(new User(52, "fertad69", 0, "Blu", 0, 2, 0));

            LeaderUser.Add(new User(51, "Zac", 0, "Verde", 0, 3, 0));
            LeaderUser.Add(new User(70, "danikoch ", 0, "Verde", 0, 3, 0));

            LeaderUser.Add(new User(48, "Bo", 0, "Giallo", 0, 4, 0));
            LeaderUser.Add(new User(83, "matte1", 0, "Giallo", 0, 4, 0));

            LeaderUser.Add(new User(60, "Cocc", 0, "Marrone", 0, 5, 0));
            LeaderUser.Add(new User(176, "Baby", 0, "Marrone", 0, 5, 0));

            LeaderUser.Add(new User(77, "Francesco", 0, "Arancione", 0, 6, 0));
            LeaderUser.Add(new User(81, "nonsonostatoio", 0, "Arancione", 0, 6, 0));

            LeaderUser.Add(new User(138, "la chiamavano jeeg robot", 0, "Giallo", 0, 7, 0));
            LeaderUser.Add(new User(89, "rIO_sK", 0, "Giallo", 0, 7, 0));

            return LeaderUser;

        }


        public List<User> loadSuperUserV4() {

            //Regione Azzurro pagerack

            List<User> LeaderUser = new List<User>();

            LeaderUser.Add(new User(1, "imdb.com", 0, "Rossa", 0, 1, 0));

            LeaderUser.Add(new User(47, "lauraw", 0, "Blu", 0, 2, 0));
            LeaderUser.Add(new User(81, "fertad69", 0, "Blu", 0, 2, 0));

            LeaderUser.Add(new User(51, "Zac", 0, "Verde", 0, 3, 0));
            LeaderUser.Add(new User(176, "danikoch ", 0, "Verde", 0, 3, 0));

            LeaderUser.Add(new User(48, "Bo", 0, "Giallo", 0, 4, 0));
            LeaderUser.Add(new User(83, "matte1", 0, "Giallo", 0, 4, 0));

            LeaderUser.Add(new User(77, "Cocc", 0, "Marrone", 0, 5, 0));
            LeaderUser.Add(new User(70, "Baby", 0, "Marrone", 0, 5, 0));

            LeaderUser.Add(new User(138, "Francesco", 0, "Arancione", 0, 6, 0));
            LeaderUser.Add(new User(52, "nonsonostatoio", 0, "Arancione", 0, 6, 0));

            LeaderUser.Add(new User(89, "la chiamavano jeeg robot", 0, "Giallo", 0, 7, 0));
            LeaderUser.Add(new User(5, "rIO_sK", 0, "Giallo", 0, 7, 0));

            return LeaderUser;

        }


        public List<User> loadSuperUserV5() {

            //Regione Arancione Degree

            List<User> LeaderUser = new List<User>();

            LeaderUser.Add(new User(172, "imdb.com", 0, "Rossa", 0, 1, 0));

            LeaderUser.Add(new User(126, "lauraw", 0, "Blu", 0, 2, 0));
            LeaderUser.Add(new User(175, "fertad69", 0, "Blu", 0, 2, 0));

            LeaderUser.Add(new User(150, "Zac", 0, "Verde", 0, 3, 0));
            LeaderUser.Add(new User(14, "danikoch ", 0, "Verde", 0, 3, 0));

            LeaderUser.Add(new User(71, "Bo", 0, "Giallo", 0, 4, 0));
            LeaderUser.Add(new User(145, "matte1", 0, "Giallo", 0, 4, 0));

            LeaderUser.Add(new User(15, "Cocc", 0, "Marrone", 0, 5, 0));
            LeaderUser.Add(new User(58, "Baby", 0, "Marrone", 0, 5, 0));

            LeaderUser.Add(new User(151, "Francesco", 0, "Arancione", 0, 6, 0));
            LeaderUser.Add(new User(130, "nonsonostatoio", 0, "Arancione", 0, 6, 0));

            LeaderUser.Add(new User(100, "la chiamavano jeeg robot", 0, "Giallo", 0, 7, 0));
            LeaderUser.Add(new User(98, "rIO_sK", 0, "Giallo", 0, 7, 0));

            return LeaderUser;

        }

        public List<User> loadSuperUserV6() {

            //Regione Verde pagerack

            List<User> LeaderUser = new List<User>();

            LeaderUser.Add(new User(172, "imdb.com", 0, "Rossa", 0, 1, 0));

            LeaderUser.Add(new User(150, "lauraw", 0, "Blu", 0, 2, 0));
            LeaderUser.Add(new User(100, "fertad69", 0, "Blu", 0, 2, 0));

            LeaderUser.Add(new User(126, "Zac", 0, "Verde", 0, 3, 0));
            LeaderUser.Add(new User(14, "danikoch ", 0, "Verde", 0, 3, 0));

            LeaderUser.Add(new User(71, "Bo", 0, "Giallo", 0, 4, 0));
            LeaderUser.Add(new User(175, "matte1", 0, "Giallo", 0, 4, 0));

            LeaderUser.Add(new User(15, "Cocc", 0, "Marrone", 0, 5, 0));
            LeaderUser.Add(new User(58, "Baby", 0, "Marrone", 0, 5, 0));

            LeaderUser.Add(new User(151, "Francesco", 0, "Arancione", 0, 6, 0));
            LeaderUser.Add(new User(130, "nonsonostatoio", 0, "Arancione", 0, 6, 0));

            LeaderUser.Add(new User(145, "la chiamavano jeeg robot", 0, "Giallo", 0, 7, 0));
            LeaderUser.Add(new User(98, "rIO_sK", 0, "Giallo", 0, 7, 0));

            return LeaderUser;

        }




        public List<User> loadSuperUserV0() {

            List<User> LeaderUser = new List<User>();

            LeaderUser.Add(new User(172, "imdb.com", 0, "Rossa", 0, 1, 0));

            LeaderUser.Add(new User(36, "lauraw", 0, "Blu", 0, 2, 0));
            LeaderUser.Add(new User(161, "fertad69", 0, "Blu", 0, 2, 0));

            LeaderUser.Add(new User(122, "Zac", 0, "Verde", 0, 3, 0));
            LeaderUser.Add(new User(12, "danikoch ", 0, "Verde", 0, 3, 0));

            LeaderUser.Add(new User(76, "Bo", 0, "Giallo", 0, 4, 0));
            LeaderUser.Add(new User(115, "matte1", 0, "Giallo", 0, 4, 0));

            LeaderUser.Add(new User(10, "Cocc", 0, "Marrone", 0, 5, 0));
            LeaderUser.Add(new User(22, "Baby", 0, "Marrone", 0, 5, 0));

            LeaderUser.Add(new User(1, "Francesco", 0, "Arancione", 0, 6, 0));
            LeaderUser.Add(new User(67, "nonsonostatoio", 0, "Arancione", 0, 6, 0));

            LeaderUser.Add(new User(164, "la chiamavano jeeg robot", 0, "Giallo", 0, 7, 0));
            LeaderUser.Add(new User(61, "rIO_sK", 0, "Giallo", 0, 7, 0));

            return LeaderUser;

        }


    }




}


